program PINi; { RTK 2008.3.1 }
const MaxN = 6; MaxM = 1000000;
var n, b, m, mm: integer;
  
  function Nasl(Pin: integer): integer;
  var i, Vsota, Novi: integer;
  begin
    Novi := (Pin mod mm) * b; Vsota := 0;
    for i := 1 to n do begin
      Vsota := Vsota + Pin mod b;
      Pin := Pin div b;
    end; {for i}
    Nasl := Novi + Vsota mod b;
  end; {Nasl}
  
var 
  z, u, v, StCiklov, d, DolzinaZ, StKrajsih: integer; F: text;
  ZeVidel: packed array [0..MaxM - 1] of boolean;
begin {PINi}
  { Preberimo vhodne podatke. }
  if ParamCount > 0 then Assign(F, ParamStr(1)) else Assign(F, 'pini.in');
  Reset(F); ReadLn(F, n); b := 10;
  m := 1; for u := 1 to n do m := m * b; { m = 10^n }
  mm := m div b; { mm = 10^(n - 1) }
  ReadLn(F, z); Close(F);
  
  for u := 0 to m - 1 do ZeVidel[u] := false;
  { Poglejmo, po koliko korakih se zane ponavljati PIN z. }
  v := z; d := 0;
  while not ZeVidel[v] do begin ZeVidel[v] := true; d := d + 1; v := Nasl(v) end;
  StCiklov := 1; DolzinaZ := d; StKrajsih := 0;
  { Preglejmo zdaj e ostale PINe. }
  for u := 0 to m - 1 do if not ZeVidel[u] then begin
    { Raunajmo naslednike u-ja, dokler ne pridemo spet do u. }
    d := 0; v := u;
    while not ZeVidel[v] do begin ZeVidel[v] := true; d := d + 1; v := Nasl(v) end;
    StCiklov := StCiklov + 1;
    { Na tem ciklu je d PINov, ki se zanejo ponavljati po d korakih. 
      Je to manj kot pri PINu z, ki se zane ponavljati po DolzinaZ korakih? }
    if d < DolzinaZ then 
      StKrajsih := StKrajsih + d;
  end; {for u}
  
  if ParamCount > 1 then Assign(F, ParamStr(2)) else Assign(F, 'pini.out');
  Rewrite(F);
  WriteLn(F, DolzinaZ);
  WriteLn(F, StKrajsih);
  WriteLn(F, StCiklov);
  Close(F);
end. {PINi}
