#include <stdio.h> /* RTK 2008.3.3 - reitev s tabelo po dolinah */
#include <stdbool.h>

#define MaxN 1000000
int mi[MaxN], di[MaxN];

int main(int argc, char **argv)
{
	int n, b, i, j, d, dNaj, m, *T;

	/* Preberimo vhodne podatke. */
	FILE *f = fopen(argc > 1 ? argv[1] : "spageti.in", "rt");
	fscanf(f, "%d %d", &n, &b);
	for (i = 0, dNaj = 0; i < n; i++)
	{
		fscanf(f, "%d %d", &mi[i], &di[i]);
		if (di[i] > dNaj) dNaj = di[i];
	}

	/* Pripravimo tabelo s tevilom pagetov za vsako dolino. */
	T = (int *) malloc((dNaj + 1) * sizeof(int));
	for (d = 0; d <= dNaj; d++) T[d] = 0;
	for (i = 0; i < n; i++) T[di[i]] += mi[i];

	/* Lomimo pagete. */
	for (d = dNaj; d > 1; d--)
	{
		m = T[d]; if (m <= 0) continue;
		if (m > b) break;
		b -= m;
		T[d / 2] += m;
		T[(d + 1) / 2] += m;
	}
	free(T);

	/* Izpiimo rezultat. */
	f = fopen(argc > 2 ? argv[2] : "spageti.out", "wt");
	fprintf(f, "%d\n", d); fclose(f); return 0;
}
